const appRootDir = require('app-root-dir');
const gulp = require('gulp');
const Karma = require('karma');

const basePath = appRootDir.get();
const distFile = basePath + '/' + (require(basePath + '/package.json').main);

const babelPolyfill = basePath + '/node_modules/babel-polyfill/dist/polyfill.min.js';
const testFiles = basePath + '/test/**/*.spec.js';

gulp.task('extension:test', function () {
  const preprocessors = {};

  preprocessors[testFiles] = 'babel';

  const server = new Karma.Server({
    frameworks: [
      'mocha',
      'chai',
      'sinon'
    ],
    files: [
      babelPolyfill,
      distFile,
      testFiles,
    ],
    browsers: ['ChromeHeadless'],
    reporters: ['mocha'],
    singleRun: true,
    preprocessors: preprocessors
  });

  server.start();
});
